     #include <iostream>
     #include <fstream>

     #include <ginac/ginac.h>
     using namespace std;
     using namespace GiNaC;
     numeric co[100];
     symbol x("x"),y("y"),z("z");
     ex polynom;
     ex polyda[50];
     ex pima[20];
     ex pnext[20];

     ex inversedaex(ex ,ex, int );
     ex minpolex(ex ,ex, int );
     ex productda(ex,ex,ex );
     int coef(ex);
     numeric valuefunction(ex,ex,numeric,int);
     numeric newtonsol(ex,numeric);
     numeric abscoef(ex);
     numeric toint(numeric);
     int cfilein();
     int checkpol2(ex);
     numeric ketaget(numeric);
     numeric ketagetpol(ex);
     numeric maxda(numeric*,int);
     numeric fvaluegen2(numeric,int,int,int);
     numeric getfareygen(numeric,int,int,int);
     int getfarey(long,int);
     int mindoreex(numeric*,int);
     int cfileinex(int);


     int main(){
       long m,count,maxketa,k;

       maxketa=30; /*  The limit of the decimal height. If the decimal height of the iterating one is bigger than the limit, we quit this program. */    
       count=1000000; /*  The limit of the number of iterating. If we can not the periodicity of the iterating one until the number, we quit this program. */
       k=getfarey(count,maxketa);
       return 0; 

     }


int getfarey(long count,int maxketa)
{
         ex p1,p2,p3,p4,p5,p6,p7,p8,z,pol;
         ex q1,q2,q3,q4,pt1,pt2,pt3,pt4;
         ex r1,r2,r3,r4;
         ex qt1,qt2,qt3,qt4,qt5;
         ex polyya[10000][20];
         ex polybuf[300][20];
         ex polybuf2[450][20];
         numeric ketaya[50],data[50];
         numeric n1,n2,nu,nda,nint,n3,n4,nb1,nb2,nb3,nb4,nketa,nketa2;
         long i,j,k,n,l,flag,firstnum,lastnum,period,jj,ii;
         long jisu=5;

         long look,m;
         int dim,tflag;
         int doko,j1,j2,j3,j4;
         int j5[50],j6[50];
         double da;

         Digits=600;
         double d1,d2;
         
         cout << "count " << count << endl;
         cout << "maxketa " << maxketa << endl;
         
         /*  "polynom" is a polynomial defined in the file "polydaex.txt".  */
         /*   "dim"=degree of the polynomial "pol"  */
         dim=cfilein();
         pol=polynom;
         j=checkpol2(pol);
         if(j<0){
             cout << "reducible" << endl;
             return 0;
         }
         j3=0;

         /*  Generation of Ind.  */
         for(j1=0;j1<dim-1;j1++){
                 for(j2=j1+1;j2<dim;j2++){
                     j5[j3]=j1;
                     j6[j3]=j2;
                     j3++;
                 }
         }


         
         nu=abscoef(pol);
         /* "nda" is a root of pol by Newton's method.*/
         nda=newtonsol(pol,nu);

         p2=pol.subs(x==nda);
         n1=ex_to<numeric>(p2);
         /* polyda[0],...,polyda[dim-1] are difined in the file "baseex.txt"     */
         k=cfileinex(dim+1);
         n2=0;


         for(j=0;j<dim-1;j++){
               p1=polyda[j].subs(x==nda);
               n1=ex_to<numeric>(p1);
               if(n1<0){
                   cout << "Out of range";
                   return 0;
               }
               n2=n2+n1;
         }
         if(n1>1){
                   cout << "Out of range"<< endl;
                   return 0;
         }


         look=0;

         /*  The first data */
         cout << "---------------------------------------" << endl;
         cout << "number" << "0" << endl;
         for(j=0;j<dim-1;j++){
               cout << polyda[j] << endl;
         }

         for(j=0;j<dim-1;j++){
            polyya[look][j]=polyda[j];
         }
 

         for(i=0;i<dim-1;i++){
            p1=polyda[i];
            p2=minpolex(p1,pol,dim);
            ketaya[i]=ketagetpol(p2);
         }
         nketa=maxda(ketaya,dim-1);
         nketa2=nketa;

         look=0;
         flag=0;
         for(i=0;i<count;i++){
         
             for(j=0;j<dim-1;j++){
            
               p1=polyda[j];
               p2=minpolex(p1,pol,dim);
               ketaya[j]=ketagetpol(p2);
             }
             for(j=0;j<dim-1;j++){
                    pima[j]=polyda[j];
             }

    
             for(j=0;j<j3;j++){
             /* In "fvaluegen2" the value $v_r$ is calculated for each $(i,j)\in Ind$.   */
                    data[j]=fvaluegen2(nda,dim,j5[j],j6[j]);
         
             }

  
             n3=maxda(ketaya,dim-1);
             if(n3>nketa)
                nketa=n3; 
	     
             /* "mindoreex" return the element of Ind which has the minimum value. */
             k=mindoreex(data,j3);

             /* The following block is a display of $\epsilon \in Ind$ */ 
             if(j6[k]<dim-1){
                p1=polyda[j5[k]].subs(x==nda);
                n1=ex_to<numeric>(p1);
                p1=polyda[j6[k]].subs(x==nda);
                n2=ex_to<numeric>(p1);
                if(n1>n2){           
                   cout << "Ind: "<< j5[k]+1 << " " <<  j6[k]+1 << endl;

                }
                else{
                   cout << "Ind: "<< j6[k]+1 << " " <<  j5[k]+1 << endl;

                } 

             }
             
             else{
                p1=0;
                for(j=0;j<dim-1;j++){
                 p1=p1+polyda[j];
                }
                p2=p1.subs(x==nda);
                n2=ex_to<numeric>(p2);
                n2=1-n2;
                p1=polyda[j5[k]].subs(x==nda);
                n1=ex_to<numeric>(p1);
                if(n1>n2){           
                   cout << "Ind: "<< j5[k]+1 << " " <<  "0" << endl;

                }
                else{
                   cout << "Ind: "<< "0" << " " <<  j5[k]+1 << endl;

                }



             } 
              

             cout << "decimal height " << n3 << " max decimal height " << nketa <<  " first decimal height " << nketa2 << endl;
             if(n1>maxketa){
                   return i;
             }
             /* In "getfareygen" the iteration of the data is given.*/
             n1=getfareygen(nda,dim,j5[k],j6[k]);
             for(j=0;j<dim-1;j++){
                 polyda[j]=pnext[j];
             }
            cout << "---------------------------------------" << endl;
            cout << "number" << i+1 <<  endl;
            for(j=0;j<dim-1;j++){
               cout << polyda[j] << endl;
            }
            /*  We check the periodicity every 200 times. */
            m=i+1-200*((i+1)/200);
            if(m==0){
               look++;
               for(j=0;j<dim-1;j++){
                   polyya[look][j]=polyda[j];
               }
            }



            
            for(j=0;j<look+1;j++){
                tflag=0;
                for(l=0;l<dim-1;l++){
                     if(polyya[j][l]==polyda[l])
                       tflag++;  
                }
             if(tflag==dim-1){
                    jj=j;
                    if(j<look){
                         flag=1;   
                         firstnum=j*200;
                         lastnum=i;
                         break;
                    }else{
                       if(i+1>200*look){
                         flag=1;   
                         firstnum=j*200;
                         lastnum=i;
                         break;
                       }
                    }

                }



            }

            if(flag>0)break;
           
         }
         if(flag>0){

            if(jj==0){

                /*  In this case we have a purly periodic case.  */
                cout << "period" << endl;
                cout << lastnum-firstnum+1 << endl;
                cout << "first" << endl;
                cout <<  firstnum << endl;
                cout << "last" << endl;
                cout <<  lastnum << endl;
                cout << "decimal height" << endl;
                cout <<  nketa << endl;
                cout << "relatively decimal height" << endl;
                cout <<  nketa/nketa2 << endl;
	


            }

            if(jj>0){
                /*  In this case we have a eventually periodic case.  */

                cout << "Wait" << endl;
  

                for(k=0;k<dim-1;k++){
                    polybuf[0][k]=polyya[jj-1][k];
                    polyda[k]=polyya[jj-1][k];
                }
                for(i=0;i<200;i++){
                     for(j=0;j<dim-1;j++){
                            pima[j]=polyda[j];
                     }

		     for(j=0;j<j3;j++){
                            data[j]=fvaluegen2(nda,dim,j5[j],j6[j]);
                     }

                      k=mindoreex(data,j3);
                      n1=getfareygen(nda,dim,j5[k],j6[k]);
                      for(j=0;j<dim-1;j++){
                         polyda[j]=pnext[j];
                       }
                      for(j=0;j<dim-1;j++){
                         polybuf[i+1][j]=polyda[j];
                      }

                
		}

               for(k=0;k<dim-1;k++){
                    polybuf2[0][k]=polyya[look-1][k];
                    polyda[k]=polyya[look-1][k];
               }
               for(i=0;i<400;i++){
                     for(j=0;j<dim-1;j++){
                            pima[j]=polyda[j];
                     }
                     for(j=0;j<j3;j++){
                            data[j]=fvaluegen2(nda,dim,j5[j],j6[j]);
                     }
                      k=mindoreex(data,j3);
                      n1=getfareygen(nda,dim,j5[k],j6[k]);
                      for(j=0;j<dim-1;j++){
                         polyda[j]=pnext[j];
                       }
                      for(j=0;j<dim-1;j++){
                         polybuf2[i+1][j]=polyda[j];
                     }

		 
	       }		 
		 
               k=lastnum+1-200*look+200;



               for(i=0;i<200;i++){
                   tflag=0;
                   for(l=0;l<dim-1;l++){
                     if(polybuf[200-i][l]==polybuf2[k-i][l])
                               tflag++;  
                   }
                   if(tflag<dim-1){
                      break;
                   }

               }
               i--;
               firstnum=firstnum-i;
               lastnum=lastnum-i;
               cout << "period" << endl;
               cout << lastnum-firstnum+1 << endl;
               cout << "first" << endl;
               cout <<  firstnum << endl;
               cout << "last" << endl;
               cout <<  lastnum << endl;
               cout << "decimal height" << endl;
               cout <<  nketa << endl;
               cout << "relatively decimal height" << endl;
               cout <<  nketa/nketa2 << endl;
         
            }



         }else{
              cout << "no period" << endl;

         }
       
         return -1; 

     }


   


      /* In "valuefunction" the value for $(i,j)\in Ind$ is calculated.  */
     numeric valuefunction(ex pol1,ex pol2,numeric nda,int dim){
        numeric n1,n2,n6;
        ex p0,p1,p2,p3,p4,p5,p6,pol;
        int j;
      /* For the pair "pol1,pol2" the value : the norm("pol1\times pol2")/|pol1\times pol2|^2.5 is given.*/
 
        pol=polynom;
        p1=pol1;
        p2=pol2;
        p3=productda(p1,p2,pol);
        p4=minpolex(p3,pol,dim);
        j=coef(p4);
        n1=co[1];
        p5=p3.subs(x==nda);
        n2=ex_to<numeric>(p5);
        n2=abs(n2);
        p6=pow(n2,2.5);
        n6=ex_to<numeric>(p6);
        return abs(n1/n6); 

    }
     
     numeric newtonsol(ex pol,numeric nu){
        ex p1,p2,p3,p4,p5;
        numeric n1,n2;
        int i;
        p1=pol;
        n1=nu;
        for(i=0;i<200;i++){
           p2=p1.diff(x); 
           p3=p1.subs(x==n1);
           p4=p2.subs(x==n1);
           p5=n1-p3/p4;
           n2=ex_to<numeric>(p5);
           n1=n2;
        }
        return n1;
     }
     int coef(ex pol){
           ex p1,p2,p3,p4,p5;
           numeric n1,n2,n3;
           int i,flag;
           flag=1;
           for(i=0;i<50;i++){
              co[i]=0;
           }


           i=0;
           n3=1;
           p1=pol;
           do{
               p2=p1.subs(x==0);
               n2=ex_to<numeric>(p2);
               n2=n2/n3;
               co[i+1]=n2;
               i++;
               n3=n3*i;
               p2=p1.diff(x);
               p1=p2;
               if(p1==0){
                     flag=-1;
               }
           }while(flag>0);
           co[0]=i-1;
           return 0;

     }

     numeric abscoef(ex pol){
           ex p1;
           numeric n1,n2,n3;

           int i,j;
           p1=pol;
           j=coef(p1);
           n1=0.0;
           for(i=1;i<co[0]+2;i++){
             n1=n1+abs(co[i]);
           }
           return n1;

     }
     numeric toint(numeric nu)
     {
         int i,j,k=1000,pm,flag=0;
         double d1;
         numeric n1,n2,n3(0),mae;
         n1=nu;
         if(n1>0)
            pm=1;
         if(n1<0)
            pm=-1;
         if(n1==0)
            pm=0;
         n1=pm*n1;
         mae=0;
         for(i=0;i<200;i++){
           if(n1<1000){
               flag=i+1;
               break;
           }
           if(flag==0){
              mae=n1;
              n1=n1/1000;
           }
         }
         for(i=0;i<flag;i++){
            d1=n1.to_double();
            j=(int)d1;
            n3=n3*1000+j;
            n1=1000*n1-1000*j;
         }
         return n3;
     }
     ex productda(ex p1,ex p2,ex p3){
         ex p4,p5;
         
         p4=p1*p2;
         p5=expand(p4);
         p4=rem(p5,p3,x);
 
         return p4;

     }

     ex inversedaex(ex pol1,ex pol2, int dim){
         ex p0,p1,p2,p3,p4,p5,p6,p7;
         int i,j;
         numeric nc[20][20];
         matrix A1(dim, dim);
         matrix A2(dim, dim);

         p0=1;
         p1=x;
         p2=pol1;
         for(i=0;i<dim;i++){
               j=coef(p2);
               for(j=0;j<dim;j++){
                 nc[i][j]=co[j+1];
               }
               p0=p0*p1;
               p2=productda(pol1,p0,pol2);

         }
         for(i=0;i<dim;i++){
           for(j=0;j<dim;j++){
              A1(i,j)=nc[i][j];
           }
         }
         A2=A1.inverse();
         p0=1;
         p1=x;
         p3=0;

         for(j=0;j<dim;j++){
              p3=p3+A2(0,j)*p0;
              p0=p0*p1;
         }

         return p3;


     }

    

     ex minpolex(ex pol1,ex pol2,int dim){

         ex p0,p1,p2,p3,p4,p5,p6,p7;
         int i,j;
         numeric nc[20][20];
         matrix A1(dim, dim);

         p0=1;
       
         p1=x;
         p2=pol1;
         for(i=0;i<dim;i++){
               j=coef(p2);
               for(j=0;j<dim;j++){
                 nc[i][j]=co[j+1];
               }
               p0=p0*p1;
               p2=productda(pol1,p0,pol2);

         }
         for(i=0;i<dim;i++){
           for(j=0;j<dim;j++){
              A1(i,j)=nc[i][j];
           }
         }
         p3=A1.charpoly(x); 
         return p3;

     }


   

      int cfilein(){
           int i,j;
           ex p1,p2;
           string s;
 
           ifstream fin("polydaex.txt");
           fin >> s;
           ex px(s, lst(x));
           polynom=px;
           j=px.degree(x); 
           fin.close();
           return j;


     }
     
      int cfileinex(int dim){
           int i,j,k;
           ex p1,p2;
           string s;

           ifstream fin("baseex.txt");
           for(i=0;i<dim-1;i++){
              fin >> s;
              ex px(s, lst(x));
              polyda[i]=px;
           }
           fin.close();
           return 0;
      }

     int checkpol2(ex pol){
     
           int i,j,k;
           ex p1,p2,p3;
           numeric n1,n2;

           k=coef(pol);
           n1=co[1];
           if(n1<0)
              n1=-n1;
           for(i=0;i<n1+1;i++){
              p1=pol.subs(x==i);
              n2=ex_to<numeric>(p1);
              if(n2==0){
                 return -1;
              } 
              p1=pol.subs(x==-i);
              n2=ex_to<numeric>(p1);
              if(n2==0){
                 return -1;
              }
           }
           

          
        
           return 1;

     }




     int mindoreex(numeric dat[],int k){
        int i,j,m;
        numeric n1;
        j=0;
        while(dat[j]<0){
           j++;

        }

        n1=dat[j];
        m=j;
        for(i=j+1;i<k;i++){
            if(dat[i]<n1&&dat[i]>0){
               m=i;
               n1=dat[i];
            }


        }
        return m;

     }

    

     numeric ketaget(numeric n0){
         int i,j,k;
         numeric n1,n2,n3,n4,n5,n6,keta;         
         keta=0;
         ex p1,p2,p3;
         n1=abs(n0);
         n2=denom(n1);
         p2=log(10.0);
         n6=ex_to<numeric>(p2);
         if(n1==0)
             return 0;

         p1=log(n2);
         n4=ex_to<numeric>(p1);
         n4=n4/n6;
         n5=toint(n4);
         n5=n5+1;
         keta=n5;
         n3=numer(n1);
         p1=log(n3);
         n4=ex_to<numeric>(p1);
         n4=n4/n6;
         n5=toint(n4);
         n5=n5+1;
         if(n5>keta)
             keta=n5;
         return keta;

     }
     
 
     numeric ketagetpol(ex pol1){
         int i,j,k;
         numeric n0,n1,n2,n3,keta;
         keta=0;
         j=coef(pol1);
         n0=abs(co[0]);
         keta=0;
         for(i=1;i<n0+2;i++){
           n2=ketaget(co[i]);
           if(n2>keta)
               keta=n2;
         }

         return keta;


     }
     
     numeric maxda(numeric dat[],int k){
         int i;
         numeric n1;
         n1=dat[0];
         for(i=1;i<k;i++){
           if(n1<dat[i]){
               n1=dat[i];
           }

         }
         return n1;

     }


      numeric fvaluegen2(numeric nda,int dim,int doko1,int doko2){
         symbol p("p"),q("q");
         ex p1,p2,p3,p4,p5,p6,p7,p8,pol,pp2;
         ex q1,q2;
         ex r1,r2,r3,r4;
         ex qt1,qt2,qt3,qt4,qt5;
         numeric n1,n2,nu,nint,n3,n4,n5;
         long k1,k2,i,j,k,n,l,flag;
         long jisu=5;
         int tflag;
         float ra=2.0;
         double da;
         double d1;
         pol=polynom;
         k1=doko1;
         k2=doko2;
         if(k1<dim-1&&k2<dim-1){
              p1=pima[k1];
              p2=pima[k2];
              q1=p1.subs(x==nda);
              n1=ex_to<numeric>(q1);
              q2=p2.subs(x==nda);
              n2=ex_to<numeric>(q2);
              if(n1<n2){
                    p3=p1*p2;
              }
              else{
                    p3=p2*p1;
	      }	
              /* In "valuefunction" the value for $(i,j)\in Ind$ is calculated.  */
	      n1=valuefunction(p1,p2,nda,dim);
              return n1;
        }
        if(k2<dim-1){
           j=k1;
           k1=k2;
           k2=j;
        }
        n2=0;
        for(i=0;i<dim-1;i++){
                 p1=pima[i];
                 q1=p1.subs(x==nda);
                 n1=ex_to<numeric>(q1);
                 n2=n2+n1;
        }
        p1=pima[k1];
        q1=p1.subs(x==nda);
        n1=ex_to<numeric>(q1);
        if(1-n2>n1){
              p2=0;
              for(i=0;i<dim-1;i++){
                     p2=p2+pima[i];
              }
              p3=p1*(1-p2);
        }
        else{
              p2=0;
              for(i=0;i<dim-1;i++){
                     p2=p2+pima[i];
              }
               p3=p1*(1-p2);
        }
         n1=valuefunction(p1,1-p2,nda,dim);
        return n1;
    }










   numeric getfareygen(numeric nda,int dim,int doko1,int doko2){
         ex p1,p2,p3,p4,p5,p6,p7,p8,pol,q1,q2,q3,q4;
         numeric n1,n2,n3,n4,n5;
         long k1,k2,i,j,k,n,l;
   
         pol=polynom;
         k1=doko1;
         k2=doko2;
         if(k1<dim-1&&k2<dim-1){
              p1=pima[k1];
              p2=pima[k2];
              q1=p1.subs(x==nda);
              n1=ex_to<numeric>(q1);
              q2=p2.subs(x==nda);
              n2=ex_to<numeric>(q2);
              if(n1<n2){
                    p3=1-p1;
                    p4=inversedaex(p3,pol,dim); 
                    for(i=0;i<dim-1;i++){
                      p5=pima[i];
                      if(i==k2){
                          p5=pima[k2]-pima[k1];
                      } 
                      pnext[i]=productda(p5,p4,pol);
                    }
              }
              else{
	            p3=1-p2;
                    p4=inversedaex(p3,pol,dim); 
                    for(i=0;i<dim-1;i++){
                      p5=pima[i];
                      if(i==k1){
                          p5=pima[k1]-pima[k2];
                      } 
                      pnext[i]=productda(p5,p4,pol);
                    }
	      }	
              return 0;
         }
         
         if(k2<dim-1){
             
            j=k1;
            k1=k2;
            k2=j;
         }
         n2=0;
         for(i=0;i<dim-1;i++){
                  p1=pima[i];
                  q1=p1.subs(x==nda);
                  n1=ex_to<numeric>(q1);
                  n2=n2+n1;
         }
         p1=pima[k1];
 
         q1=p1.subs(x==nda);
         n1=ex_to<numeric>(q1);

         if(1-n2>n1){
               p3=1-p1;
               p4=inversedaex(p3,pol,dim);
               for(i=0;i<dim-1;i++){
                      p5=pima[i];
                      pnext[i]=productda(p5,p4,pol);
        
               }
         }
         else{
               p2=0;
               for(i=0;i<dim-1;i++){
                      p2=p2+pima[i];
               }
               p4=inversedaex(p2,pol,dim);
               for(i=0;i<dim-1;i++){
                      p5=pima[i];
                      if(i==k1){
                          p5=pima[k1]+p2-1;
                      } 
                      pnext[i]=productda(p5,p4,pol);
               }



         }

         return 0;


     }









